"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var StringUtils_1=require("../utils/StringUtils"),ObjectUtils_1=require("../utils/ObjectUtils"),ArrayUtils_1=require("../utils/ArrayUtils"),HashMapObject_1=require("../model/HashMapObject"),HTTPManagerGetRequest_1=require("./httpmanager/HTTPManagerGetRequest"),HTTPManagerBaseRequest_1=require("./httpmanager/HTTPManagerBaseRequest"),HTTPManager=function(){function t(t){if(void 0===t&&(t=!0),this.asynchronous=!0,this.timeout=0,this.internetCheckLocations=["https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js","https://ajax.aspnetcdn.com/ajax/modernizr/modernizr-2.8.3.js","https://code.jquery.com/jquery-3.2.1.slim.min.js"],this._queues=[],"boolean"!=typeof t)throw new Error("asynchronous is not boolean");this.asynchronous=t}return t.prototype.createQueue=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0,r=this._queues;e<r.length;e++){if(r[e].name===t)throw new Error("queue "+t+" already exists")}this._queues.push({name:t,isRunning:!1,pendingRequests:[]})},t.prototype.countQueues=function(){return this._queues.length},t.prototype.isQueueRunning=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0,r=this._queues;e<r.length;e++){var n=r[e];if(n.name===t)return n.isRunning}throw new Error("queue "+t+" does not exist")},t.prototype.deleteQueue=function(t){if(StringUtils_1.StringUtils.isEmpty(t))throw new Error("name must be a non empty string");for(var e=0;e<this._queues.length;e++)if(this._queues[e].name===t){if(this._queues[e].isRunning)throw new Error("queue "+t+" is currently running");return void this._queues.splice(e,1)}throw new Error("queue "+t+" does not exist")},t.prototype.generateUrlQueryString=function(t){var e="",r=[],n=[];if(ObjectUtils_1.ObjectUtils.isObject(t)&&ObjectUtils_1.ObjectUtils.getKeys(t).length>0){if(t instanceof HashMapObject_1.HashMapObject)r=t.getKeys(),n=t.getValues();else{r=Object.getOwnPropertyNames(t);for(var i=0;i<r.length;i++)n.push(t[r[i]])}for(i=0;i<r.length;i++)e+="&"+encodeURIComponent(r[i])+"="+encodeURIComponent(n[i]);return e.substring(1,e.length)}throw new Error("keyValuePairs must be a HashMapObject or a non empty Object")},t.prototype.isInternetAvailable=function(t,e){var r=this;if("function"!=typeof t||"function"!=typeof e)throw new Error("params must be functions");if(this.internetCheckLocations.length<=0)throw new Error("no check locations specified");var n=function(i){if(i.length<=0)return e();var s=i.shift();if(!StringUtils_1.StringUtils.isUrl(s))throw new Error("invalid check url : "+s);r.urlExists(String(s+"?r="+StringUtils_1.StringUtils.generateRandom(15,15)),t,function(){return n(i)})};!1===navigator.onLine?e():n(this.internetCheckLocations.slice(0))},t.prototype.urlExists=function(t,e,r){if(!StringUtils_1.StringUtils.isString(t))throw new Error("url must be a string");if("function"!=typeof e||"function"!=typeof r)throw new Error("params must be functions");if(StringUtils_1.StringUtils.isUrl(t)){var n=new HTTPManagerGetRequest_1.HTTPManagerGetRequest(t);n.successCallback=function(){return e()},n.errorCallback=function(){return r()},this.execute(n)}else r()},t.prototype.getUrlHeaders=function(e,r,n){var i=this;if(!StringUtils_1.StringUtils.isString(e))throw new Error("url must be a string");if("function"!=typeof r||"function"!=typeof n)throw new Error("params must be functions");if(!StringUtils_1.StringUtils.isUrl(e))throw new Error("invalid url "+e);var s=new XMLHttpRequest;this.timeout>0&&(s.timeout=this.timeout),s.open("GET",e,this.asynchronous),s.onload=function(){return r(s.getAllResponseHeaders().split("\n"))},s.onerror=function(){return n(s.statusText,s.status)},s.ontimeout=function(){return n(i.timeout+t.ERROR_TIMEOUT,408)},s.send()},t.prototype.execute=function(e,r,n){var i=this;void 0===r&&(r=null),void 0===n&&(n=null);var s=this._generateValidRequestsList(e);if(null!==r&&!(r instanceof Function)||null!==n&&!(n instanceof Function))throw new Error("finishedCallback and progressCallback must be functions");for(var o=0,u=!1,a=[],l=function(t,e,i,l,g){void 0===i&&(i=!1),void 0===l&&(l=""),void 0===g&&(g=-1);var c=t.request;o++,a[t.index]={url:c.url,response:e,isError:i,errorMsg:l,errorCode:g},i?(u=!0,c.errorCallback(l,g)):c.successCallback(e),c.finallyCallback(),null!==n&&n(c.url,s.length),o>=s.length&&null!==r&&r(a,u)},g=function(){var e,r={index:h,request:s[h]};if(!StringUtils_1.StringUtils.isString(s[h].url)||StringUtils_1.StringUtils.isEmpty(s[h].url))throw new Error("url "+h+" must be a non empty string");try{e=new XMLHttpRequest}catch(t){throw new Error("Could not initialize XMLHttpRequest. If you are running node, it is not natively available. We recommend using the npm xhr2 library which emulates XMLHttpRequest for node apps")}(s[h].timeout>0||c.timeout>0)&&(e.timeout=s[h].timeout>0?s[h].timeout:c.timeout);var n=s[h]instanceof HTTPManagerGetRequest_1.HTTPManagerGetRequest?"GET":"POST";if(e.open(n,s[h].url,c.asynchronous),e.onload=function(){e.status>=200&&e.status<400?l(r,e.responseText):l(r,"",!0,e.statusText,e.status)},e.onerror=function(){l(r,"",!0,e.statusText,e.status)},e.ontimeout=function(){l(r,"",!0,i.timeout+t.ERROR_TIMEOUT,408)},"GET"===n&&e.send(),"POST"===n)try{var o=c.generateUrlQueryString(s[h].parameters);e.setRequestHeader("Content-type","application/x-www-form-urlencoded"),e.send(o)}catch(t){e.send()}},c=this,h=0;h<s.length;h++)g()},t.prototype._generateValidRequestsList=function(t){var e=[];if(ArrayUtils_1.ArrayUtils.isArray(t)){if(t.length<=0)throw new Error("No requests to execute");for(var r=0,n=t;r<n.length;r++){var i=n[r];StringUtils_1.StringUtils.isString(i)?e.push(new HTTPManagerGetRequest_1.HTTPManagerGetRequest(i)):e.push(i)}}else if(StringUtils_1.StringUtils.isString(t)&&!StringUtils_1.StringUtils.isEmpty(t))e=[new HTTPManagerGetRequest_1.HTTPManagerGetRequest(t)];else{if(!(t instanceof HTTPManagerBaseRequest_1.HTTPManagerBaseRequest))throw new Error("Invalid requests value");e=[t]}return e},t.prototype.queue=function(t,e,r){void 0===r&&(r=null);var n=this._generateValidRequestsList(t);if(null!==r&&!(r instanceof Function))throw new Error("finishedCallback and progressCallback must be functions");for(var i=0,s=this._queues;i<s.length;i++){var o=s[i];if(o.name===e){for(var u=0;u<n.length;u++)o.pendingRequests.unshift(n[u]);if(null!==r){var a=new HTTPManagerGetRequest_1.HTTPManagerGetRequest("FINISHED_REQUEST_CALLBACK");a.finallyCallback=r,o.pendingRequests.unshift(a)}return void(this.isQueueRunning(e)||this._startQueue(e))}}throw new Error("queue "+e+" does not exist. Create it with createQueue()")},t.prototype._startQueue=function(t){for(var e=this,r=function(t){if(t.pendingRequests.length<=0)t.isRunning=!1;else{if("FINISHED_REQUEST_CALLBACK"===t.pendingRequests[t.pendingRequests.length-1].url){var n=t.pendingRequests.pop();t.pendingRequests.length<=0&&(t.isRunning=!1),n.finallyCallback()}t.pendingRequests.length>0&&(t.isRunning=!0,e.execute(t.pendingRequests.pop(),function(){return r(t)}))}},n=0,i=this._queues;n<i.length;n++){var s=i[n];if(s.name===t)return void r(s)}},t.prototype.loadResourcesFromList=function(t,e,r,n,i){var s=this;if(void 0===i&&(i=null),!StringUtils_1.StringUtils.isString(t)||StringUtils_1.StringUtils.isEmpty(t))throw new Error("urlToResourcesList must be a non empty string");if(!StringUtils_1.StringUtils.isString(e)||StringUtils_1.StringUtils.isEmpty(e))throw new Error("basePath must be a non empty string");this.execute(t,function(o,u){if(o[0].isError)return n(t,o[0].errorMsg,o[0].errorCode);for(var a=[],l=e+("/"===e.charAt(e.length-1)?"":"/"),g=StringUtils_1.StringUtils.getLines(o[0].response),c=0,h=g;c<h.length;c++){var f=h[c];a.push(StringUtils_1.StringUtils.formatPath(l+f,"/"))}s.execute(a,function(t,e){for(var i=[],s=0,o=t;s<o.length;s++){var u=o[s];if(u.isError)return n(u.url,u.errorMsg,u.errorCode);i.push(u.response)}r(g,i)},i)})},t.ERROR_TIMEOUT=" ms Timeout reached",t}();exports.HTTPManager=HTTPManager;