"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var StringUtils_1=require("../utils/StringUtils"),ArrayUtils_1=require("../utils/ArrayUtils"),JavaPropertiesObject_1=require("../model/JavaPropertiesObject"),LocalizationManager=function(){function t(){this.missingKeyFormat="$exception",this.wildCardsFormat="{N}",this.isBundleMandatory=!1,this._initialized=!1,this._locales=[],this._languages=[],this._activeBundle="",this._activePath="",this._loadedData={},this._filesManager=null,this._httpManager=null}return t.prototype.isInitialized=function(){return this._initialized},t.prototype.isLocaleLoaded=function(t){return this._locales.indexOf(t)>=0},t.prototype.isLanguageLoaded=function(t){if(2!==t.length)throw new Error("language must be a valid 2 digit value");return this._languages.indexOf(t)>=0},t.prototype.initialize=function(t,e,i,r,a){var o=this;void 0===r&&(r=null),void 0===a&&(a=null),t?this._httpManager=t:this._filesManager=t,this._locales=[],this._languages=[],this._activeBundle="",this._activePath="",this._loadedData={},this._loadData(e,i,function(t){o._initialized=!0,null!==r&&r(t)},a)},t.prototype.loadLocales=function(t,e,i){if(void 0===e&&(e=null),void 0===i&&(i=null),!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before loading more locales");for(var r=[],a=0,o=Object.keys(this._loadedData);a<o.length;a++){for(var n=o[a],l=[],s=0,h=Object.keys(this._loadedData[n]);s<h.length;s++){var d=h[s];l=l.concat(Object.keys(this._loadedData[n][d]))}r.push({path:n,bundles:ArrayUtils_1.ArrayUtils.removeDuplicateElements(l)})}this._loadData(t,r,e,i)},t.prototype.loadBundles=function(t,e,i,r){if(void 0===i&&(i=null),void 0===r&&(r=null),!ArrayUtils_1.ArrayUtils.isArray(e)||0===e.length)throw new Error("no bundles specified for path: "+t);if(!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before loading more bundles");this._loadData(this._locales,[{path:t,bundles:e}],i,r)},t.prototype._loadData=function(t,e,i,r){if(void 0===i&&(i=null),void 0===r&&(r=null),!ArrayUtils_1.ArrayUtils.isArray(t)||t.length<=0)throw new Error("no locales defined");if(!ArrayUtils_1.ArrayUtils.isArray(e)||e.length<=0)throw new Error("bundles must be an array of objects");for(var a=[],o=[],n=0,l=e;n<l.length;n++)for(var s=l[n],h=0,d=s.bundles;h<d.length;h++)for(var u=d[h],c=0,g=t;c<g.length;c++){var _=g[c];o.push({locale:_,bundle:u,path:s.path}),a.push(StringUtils_1.StringUtils.replace(s.path,["$locale","$bundle"],[_,u]))}this._locales=this._locales.concat(t),null!==this._filesManager||this._loadDataFromUrls(a,o,i,r)},t.prototype._loadDataFromUrls=function(t,e,i,r){var a=this;void 0===i&&(i=null),void 0===r&&(r=null),this._locales=ArrayUtils_1.ArrayUtils.removeDuplicateElements(this._locales),this._languages=this._locales.map(function(t){return t.substr(0,2)});var o=function(t){void 0===t&&(t=[]),e.length>0&&(a._activeBundle=e[e.length-1].bundle,a._activePath=e[e.length-1].path),null!==i&&i(t)};t.length<=0?o():this._httpManager.execute(t,function(i,r){for(var n=[],l=0;l<i.length;l++)if(i[l].isError)n.push({path:i[l].url,errorMsg:i[l].errorMsg,errorCode:i[l].errorCode});else{var s=e[l].locale,h=e[l].bundle,d=e[l].path,u=StringUtils_1.StringUtils.getPathExtension(t[l]);a._loadedData.hasOwnProperty(d)||(a._loadedData[d]={}),a._loadedData[d].hasOwnProperty(s)||(a._loadedData[d][s]={}),a._loadedData[d][s][h]="json"===u?a.parseJson(i[l].response):a.parseProperties(i[l].response)}o(n)},function(t,e){null!==r&&r(t,e)})},t.prototype.locales=function(){return this._locales},t.prototype.languages=function(){return this._languages},t.prototype.activeBundle=function(){return this._activeBundle},t.prototype.primaryLocale=function(){if(!this._initialized)throw new Error("LocalizationManager not initialized");return this._locales[0]},t.prototype.primaryLanguage=function(){if(!this._initialized)throw new Error("LocalizationManager not initialized");return this._languages[0]},t.prototype.setActiveBundle=function(t){for(var e=0,i=Object.keys(this._loadedData);e<i.length;e++)for(var r=i[e],a=0,o=Object.keys(this._loadedData[r]);a<o.length;a++){var n=o[a];if(Object.keys(this._loadedData[r][n]).indexOf(t)>=0)return this._activeBundle=t,void(this._activePath=r)}throw new Error(t+" bundle not loaded")},t.prototype.setPrimaryLocale=function(t){if(!StringUtils_1.StringUtils.isString(t))throw new Error("Invalid locale value");if(!this.isLocaleLoaded(t))throw new Error(t+" not loaded");for(var e=[t],i=0,r=this._locales;i<r.length;i++){var a=r[i];a!==t&&e.push(a)}this._locales=e,this._languages=this._locales.map(function(t){return t.substr(0,2)})},t.prototype.setPrimaryLocales=function(t){if(!ArrayUtils_1.ArrayUtils.isArray(t)||ArrayUtils_1.ArrayUtils.hasDuplicateElements(t)||t.length<=0)throw new Error("locales must be non empty string array with no duplicate elements");for(var e=t.length-1;e>=0;e--)this.setPrimaryLocale(t[e])},t.prototype.setPrimaryLanguage=function(t){for(var e=0,i=this._locales;e<i.length;e++){var r=i[e];if(r.substr(0,2)===t)return this.setPrimaryLocale(r)}throw new Error(t+" not loaded")},t.prototype.setPrimaryLanguages=function(t){if(!ArrayUtils_1.ArrayUtils.isArray(t)||ArrayUtils_1.ArrayUtils.hasDuplicateElements(t)||t.length<=0)throw new Error("languages must be non empty string array with no duplicate elements");for(var e=t.length-1;e>=0;e--)this.setPrimaryLanguage(t[e])},t.prototype.setLocalesOrder=function(t){if(!ArrayUtils_1.ArrayUtils.isArray(t))throw new Error("locales must be an array");if(t.length!==this._locales.length)throw new Error("locales must contain all the currently loaded locales");for(var e=0,i=t;e<i.length;e++){var r=i[e];if(!this.isLocaleLoaded(r))throw new Error(r+" not loaded")}this._locales=t,this._languages=this._locales.map(function(t){return t.substr(0,2)})},t.prototype.get=function(t,e,i,r){if(void 0===e&&(e=""),void 0===i&&(i=""),void 0===r&&(r=[]),!this._initialized)throw new Error("LocalizationManager not initialized. Call initialize() before requesting translated texts");if(""===i&&(i=this._activePath),""===e){if(this.isBundleMandatory)throw new Error("bundle is mandatory for key "+t);e=this._activeBundle}if(-1===Object.keys(this._loadedData).indexOf(i))throw new Error("Path <"+i+"> not loaded");for(var a=0,o=this._locales;a<o.length;a++){var n=o[a];if(Object.keys(this._loadedData[i]).indexOf(n)>=0){if(-1===Object.keys(this._loadedData[i][n]).indexOf(e))throw new Error("Bundle <"+e+"> not loaded");if(Object.keys(this._loadedData[i][n][e]).indexOf(t)>=0){this._activeBundle=e,this._activePath=i;for(var l=this._loadedData[i][n][e][t],s=StringUtils_1.StringUtils.isString(r)?[String(r)]:r,h=0;h<s.length;h++)l=StringUtils_1.StringUtils.replace(l,StringUtils_1.StringUtils.replace(this.wildCardsFormat,"N",String(h)),s[h]);return l}}}if(this.missingKeyFormat.indexOf("$exception")>=0)throw new Error("key <"+t+"> not found on "+e+" - "+i);return this.missingKeyFormat.replace("$key",t)},t.prototype.getStartCase=function(t,e,i,r){return void 0===e&&(e=""),void 0===i&&(i=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,e,i,r),StringUtils_1.StringUtils.FORMAT_START_CASE)},t.prototype.getAllUpperCase=function(t,e,i,r){return void 0===e&&(e=""),void 0===i&&(i=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,e,i,r),StringUtils_1.StringUtils.FORMAT_ALL_UPPER_CASE)},t.prototype.getAllLowerCase=function(t,e,i,r){return void 0===e&&(e=""),void 0===i&&(i=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,e,i,r),StringUtils_1.StringUtils.FORMAT_ALL_LOWER_CASE)},t.prototype.getFirstUpperRestLower=function(t,e,i,r){return void 0===e&&(e=""),void 0===i&&(i=""),void 0===r&&(r=[]),StringUtils_1.StringUtils.formatCase(this.get(t,e,i,r),StringUtils_1.StringUtils.FORMAT_FIRST_UPPER_REST_LOWER)},t.prototype.parseJson=function(t){return JSON.parse(t)},t.prototype.parseProperties=function(t){for(var e={},i=new JavaPropertiesObject_1.JavaPropertiesObject(t),r=0,a=i.getKeys();r<a.length;r++){var o=a[r];e[o]=i.get(o)}return e},t}();exports.LocalizationManager=LocalizationManager;